/*
    This program calls one of the "thread functions" as a
    thread and the other "thread function" as a regular
    function. Notice that this program has two threads,
    the main thread and one child thread. The two functions
    run concurrently, one in each thread. The main thread
    blocks on pthread_join() in order to wait for the child
    thread to complete.

    Run this program many times. You should see different
    interleavings of the output strings.
*/
#include <stdio.h>    // fprintf(), stderr
#include <unistd.h>   // sleep()
#include <pthread.h>
#include <windows.h>  // win32

// function prototypes
void *thread1(void *vargp);
void *thread2(void *vargp);

int main()
{
   pthread_t tid1;

   // create the thread
   pthread_create(&tid1, NULL, thread1, NULL);  // should have error checking

   // call the function
   thread2(NULL);

   // wait for the thread to finish
   pthread_join(tid1, NULL);

   fprintf(stderr, "\nAll done.\n");

   return 0;
}


void *thread1(void *vargp) // vargp means "variable (length) argument pointer"
{
   fprintf(stderr, "hello ");
   //sleep(1);  // posix
   Sleep(1000); // win32
   fprintf(stderr, "from thread 1!\n");
   return NULL;
}


void *thread2(void *vargp)
{
   fprintf(stderr, "HELLO FROM ");
   //sleep(1);  // posix
   Sleep(1000); // win32
   fprintf(stderr, "THREAD 2?\n");
   return NULL;
}
