/*
    This program calls the "thread functions" as threads,
    that is, they are called concurrently. Notice that this
    program has three threads. The main thread blocks on
    pthread_join() in order to wait for the child threads
    to complete.

    This program passes parameters (by reference) to the threads.
    The pointers to the parameters are on each thread's stack.
    Use a virtual memory mapping program to see where stack threads
    are placed in virtual memeory.
*/
#include <stdio.h>    // fprintf(), stderr
#include <unistd.h>   // sleep()
#include <pthread.h>
#include <windows.h>  // win32

// function prototypes
void *thread1(void *vargp);
void *thread2(void *vargp);

int main()
{
   pthread_t tid[2];

   int arg1 = 101;
   int arg2 = 202;

   fprintf(stderr, "Address of arg1 = %d\n", (int)&arg1);
   fprintf(stderr, "Address of arg2 = %d\n\n", (int)&arg2);

   // create the threads
   pthread_create(&(tid[0]), NULL, thread1, &arg1);  // should have error checking
   pthread_create(&(tid[1]), NULL, thread2, &arg2);

   // wait for the threads to finish
   pthread_join(tid[0], NULL);
   pthread_join(tid[1], NULL);

   fprintf(stderr, "\nAll done.\n");

   return 0;
}


void *thread1(void *vargp)  // vargp means "variable (length) argument pointer"
{
   int arg = *((int*)vargp);  // the "void pointer" needs to be cast back into an int pointer

   fprintf(stderr, "hello ");
   //sleep(1);  // posix
   Sleep(1000); // win32
   fprintf(stderr, "from thread 1");
   //sleep(1);  // posix
   Sleep(1000); // win32
   fprintf(stderr, " with argument %d at location %d!\n", arg, (int)&vargp);

   //while(1) sleep(10);  //use this to pause the thread and look at virtual memory

   return NULL;
}


void *thread2(void *vargp)
{
   int arg = *((int*)vargp);

   fprintf(stderr, "HELLO FROM ");
   //sleep(1);  // posix
   Sleep(1000); // win32
   fprintf(stderr, "THREAD 2");
   //sleep(1);  // posix
   Sleep(1000); // win32
   fprintf(stderr, " WITH ARGUMENT %d AT LOCATION %d?\n", arg, (int)&vargp);

   //while(1) sleep(10);  //use this to pause the thread and look at virtual memory

   return NULL;
}
